> For the complete documentation index, see [llms.txt](https://docs.kaiko.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kaiko.com/cloud-delivery/data-feeds/level-2-aggregations/tokens-in-a-liquidity-pool/tokens-in-a-liquidity-pool-uniswap-v3.md).

# Tokens in a liquidity pool (Uniswap v3)

## What is this dataset?&#x20;

The Uniswap V3 Liquidity Estimator offers insight into the token reserves on Uniswap V3.

{% hint style="info" %}
This data shows the liquidity across all the price levels for a specific pair of tokens on Uniswap V3. Each price level has a range, which is shown as`lower_tick` (the lowest price of the level) and `upper_tick` (the highest price of the level).\
\
The data shows you the amount of tokens and liquidity available at each price level. \
\
We display all price-levels up to 10% either side of the current block price. The data is provided in a block-by-block granularity. Access the methodology [here](https://www.kaiko.com/reports/the-dex-data-handbook?p=2920\&preview=true\&preview_id=2920\&classic=true).
{% endhint %}

### File structure details

* File Name: \[kaiko\_exchange\_code]\_\[pool\_address]\_\[date].csv
  * Files are created on a daily basis.
  * example: usp3\_0xcbfb0745b8489973bf7b334d54fdbd573df7ef3c\_2023-02-07.csv
* Cut-off time: `00:00:00 UTC`
  * We use the timestamp of the block in order to cut-off the data points between days.
* Column Delimeter: , (comma)
* Decimal Mark (in numbers): . (dot)

| Field           | Description                                                                             | Example                  |
| --------------- | --------------------------------------------------------------------------------------- | ------------------------ |
| `block_number`  | The height of the block.                                                                | `16028979`               |
| `timestamp`     | The timestamp of the block.                                                             | `1669161611000`          |
| `lower_tick`    | The lower tick of the range.                                                            | `-59580`                 |
| `upper_tick`    | The upper tick of the range.                                                            | `-59520`                 |
| `current_price` | The current price at this block, normalized using the pool’s tokens decimals.           | `0.0028577887443084`     |
| `current_tick`  | The current tick at this block.                                                         | `-58580`                 |
| `amount`        | The amount of liquidity in the specified tick range.                                    | `1.7305248294559624e+23` |
| `amount0`       | The amount of token0 in the specified tick range, normalized using the token0 decimals. | `0`                      |
| `amount1`       | The amount of token1 in the specified tick range, normalized using the token1 decimals. | `26.4381078606`          |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kaiko.com/cloud-delivery/data-feeds/level-2-aggregations/tokens-in-a-liquidity-pool/tokens-in-a-liquidity-pool-uniswap-v3.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
